#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

bool check(vector<vector<int> > &g, int mask){
    for (int i = 0; i < g.size(); ++i){
        for (int j = 0; j < g[i].size(); ++j){
            if ((mask & (1 << i)) && (mask & (1 << g[i][j]))){
                return false;
            }
        }
    }
    return true;
}

int f(int mask){
    int ans = 0;
    while (mask > 0){
        ans += mask % 2;
        mask /= 2;
    }
    return ans;
}

int main(){
    int n;
    cin >> n;
    vector<vector<int> > g(n);
    for (int v = 0; v < n; ++v){
        int u;
        cin >> u;

        if (u != -1){
            --u;
            g[v].push_back(u);
            g[u].push_back(v);
        }
    }
    int root = 0;
    if (n <= 20){
        int ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask){
            if (check(g, mask)){
                ans = max(ans, f(mask));
            }
        }
        cout << ans << endl;
    }
    else{

    }

    return 0;
}
