#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define all(v) v.begin(), v.end()

int revMask(int mask, int k){
    int ans = 0;
    for (int i = 0; i < k; ++i){
        if (!(mask & (1 << i))){
            ans |= (1 << i);
        }
    }
    return ans;
}

int nextMask(int mask, int kek, int k){
    int m = 0;
    for (int i = 0; i < k; ++i){
        if ((kek & (1 << i)) && (mask & (1 << i))){
            m |= (1 << i);
        }
    }
    --m;
    if (m < 0){
        cout << "NO" << endl;
        exit(0);
    }
    int ans = 0;
    for (int i = 0; i < k; ++i){
        if ((mask & (1 << i)) && (m & (1 << i))){
            ans |= (1 << i);
        }
    }
    return ans;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n, k;
    cin >> n >> k;
    vector<pair<vector<int>, int> > arr(n, make_pair(vector<int>(k), 0));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < k; ++j){
            cin >> arr[i].first[j];
        }
        arr[i].second = i + 1;
    }
    if (k == 1){
        sort(all(arr));
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; ++i){
            cout << arr[i].second << " " << arr[i + n / 2].second << endl;
        }
    }
    else{
        vector<int> b(k);
        for (int i = 0; i < k; ++i){
            vector<int> tmp(n);
            for (int j = 0; j < n; ++j){
                tmp[j] = arr[j].first[i];
            }
            sort(all(tmp));
            b[i] = tmp[n / 2];
        }
        vector<vector<pair<vector<int>, int> > > a(1 << k);
        vector<int> kek(n);
        for (int i = 0; i < n; ++i){
            int mask = 0;
            for (int j = 0; j < k; ++j){
                if (arr[i].first[j] >= b[j]){
                    mask |= (1 << j);
                }
                if (arr[i].first[j] == b[j]){
                    kek[i] |= (1 << j);
                }
            }
            a[mask].push_back(arr[i]);
        }
        return 0;
        vector<pair<int, int> > ans;
        for (int mask = (1 << k) - 1; mask >= (1 << k - 1); --mask){
            int rMask = revMask(mask, k);
            if (a[mask].size() > a[rMask].size()){
                cout << "NO" << endl;
                return 0;
            }
            for (int i = 0; i < a[rMask].size(); ++i){
                ans.push_back(make_pair(a[mask][i].second, a[rMask][i].second));
            }
            for (int i = a[rMask].size(); i < a[mask].size(); ++i){
                a[nextMask(mask, kek[a[mask][i].second], k)].push_back(a[mask][i]);
            }
        }
        if (ans.size() != n / 2){
            cout << "NO" << endl;
            return 0;
        }
        cout << "YES" << endl;
        for (int i = 0; i < ans.size(); ++i){
            cout << ans[i].first << " " << ans[i].second << endl;
        }
    }
    return 0;
}
/*
6 2
8 6
1 5
6 3
3 1
4 7
7 2
*/
/*
4 3
1 -1 -1
2 1 1
3 -1 1
4 1 -1
*/
