#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

int main(){
    long long k;
    cin >> k;
    assert(k >= 0);
    if (k == 0){
        cout << 0 << endl;

        return 0;
    }
    long long ans = -1;
    for (long long d = 1; d <= sqrt(k); ++d){
        if (k % d == 0){
            if ((d + k / d) % 2){
                continue;
            }
            if (ans == -1){
                ans = (d + k / d) / 2;
            }
            else{
                ans = min(ans, (d + d / k) / 2);
            }
        }
    }
    if (ans == -1){
        cout << "none" << endl;
    }
    else{
        cout << ans << endl;
    }

    return 0;
}
