#include <iostream>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

void Solve1(long long k){
    if (k == 0){
        cout << 0 << endl;

        return 0;
    }
    long long ans = -1;
    for (long long d = 1; d <= sqrt(k); ++d){
        if (k % d == 0){
            if ((d + k / d) % 2){
                continue;
            }
            if (ans == -1){
                ans = (d + k / d) / 2;
            }
            else{
                ans = min(ans, (d + k / d) / 2);
            }
        }
    }
    if (ans == -1){
        cout << "none" << endl;
    }
    else{
        cout << ans << endl;
    }
}

void Solve2(long long k){
    long long ans = -1;
    for (long long d = 1; d <= sqrt(k); ++k){
        if (k % d == 0){
            if ((d + k / d) % 2){
                continue;
            }
            if (ans == -1){
                ans = (k / d - d) / 2;
            }
            else{
                ans = min(ans, (k / d - d) / 2);
            }
        }
    }
    if (ans == -1){
        cout << "none" << endl;
    }
    else{
        cout << ans << endl;
    }
}

int main(){
    long long k;
    cin >> k;
    if (k >= 0){
        Solve1(k);
    }
    else{
        Solve2(-k);
    }

    return 0;
}
