#include <iostream>
#include <cmath>

using namespace std;

bool ok(long long n, long long k){
    if (n < k){
        return false;
    }
    long long sqrtN = sqrt(n - k);
    return sqrtN * sqrtN == n - k;
}

int main(){
    long long k;
    cin >> k;
    for (long long i = 0; i <= 2e8; ++i){
        if (ok(i * i, k)){
            cout << i << endl;

            return 0;
        }
    }
    cout << "none" << endl;

    return 0;
}
