#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int MOD = 1e9 + 7;

int main(){
    long long n, t;
    cin >> n >> t;
    if (n == t){
        cout << 1 << endl;
        return 0;
    }
    vector<vector<pair<long long, long long> > > dp(n + 1, vector<pair<long long, long long> >(n + 1, make_pair(0, 0)));
    vector<vector<pair<long long, long long> > > prefSum(2 * n + 1, vector<pair<long long, long long> >(n + 1, make_pair(0, 0)));
    for (int i = 0; i <= n; ++i){
        for (int j = 1; j <= n; ++j){
            prefSum[i][j].first = (prefSum[i][j - 1].first + prefSum[i][j].first) % MOD;
            prefSum[i][j].second = (prefSum[i][j - 1].second + prefSum[i][j].second) % MOD;
        }
        for (int j = 1; j <= n; ++j){
            if (i == 0){
                dp[i][j] = make_pair(1, 1);
                prefSum[i + j][j] = make_pair(1, 1);
                continue;
            }
            /*for (int k = 1; k < j && k <= i; ++k){
                dp[i][j].first = (dp[i][j].first + dp[i - k][k].second) % MOD;
            }
            for (int k = j + 1; k <= i; ++k){
                dp[i][j].second = (dp[i][j].second + dp[i - k][k].first) % MOD;
            }*/
            dp[i][j].first = prefSum[i][min(i, j - 1)].second;
            if (j <= i){
                dp[i][j].second = prefSum[i][i].first - prefSum[i][j].first;
            }
            prefSum[i + j][j].first = dp[i][j].first;
            prefSum[i + j][j].second = dp[i][j].second;
        }
    }
    cout << (dp[n - t][t].first + dp[n - t][t].second) % MOD << endl;

    return 0;
}
